use std::fs::File;
use std::io::prelude::*;

use clap::Parser;

use hercules_ir::*;

use hercules_interpreter::interpreter::*;
use hercules_interpreter::*;
use hercules_interpreter::value;

#[derive(Parser, Debug)]
#[command(author, version, about, long_about = None)]
struct Args {
    hir_file: String,

    #[arg(short, long, default_value_t = String::new())]
    output: String,
}

fn main() {
    let args = Args::parse();
    let module = parse_file(&args.hir_file);
    let ret_val = interp_module!(module, [2, 3, 4], 1, 3);
    
    println!("ret val: {:?}", ret_val);
}

