#![feature(future_join, box_as_ptr)]

juno_build::juno!("implicit_clone");

fn main() {
    async_std::task::block_on(async {
        let output = simple_implicit_clone(3).await;
        println!("{}", output);
        assert_eq!(output, 11);

        let output = loop_implicit_clone(100).await;
        println!("{}", output);
        assert_eq!(output, 7);

        let output = double_loop_implicit_clone(3).await;
        println!("{}", output);
        assert_eq!(output, 42);

        let output = tricky_loop_implicit_clone(2, 2).await;
        println!("{}", output);
        assert_eq!(output, 130);

        let output = tricky2_loop_implicit_clone(2, 3).await;
        println!("{}", output);
        assert_eq!(output, 39);

        let output = tricky3_loop_implicit_clone(5, 7).await;
        println!("{}", output);
        assert_eq!(output, 7);

        let output = no_implicit_clone(4).await;
        println!("{}", output);
        assert_eq!(output, 13);

        let output = mirage_implicit_clone(73).await;
        println!("{}", output);
        assert_eq!(output, 843);
    });
}

#[test]
fn implicit_clone_test() {
    main();
}
